%This M-Function was created automatically by PSG Toolbox.
%See section "Special Subroutines in Toolbox -> User Subroutine in Toolbox" in PSG Help Manual.
%
%Input variables:
%
%Inputs                      PSG Type    PSG Object             Location in Problem Statement                      Class
%matrix_sde_data             data        matrix_sde             avg_g(matrix_sde)                                  double
%                                                               pm_pen(vector_benchmark_sd, matrix_sde)
%matrix_sde_vars             vars        matrix_sde             avg_g(matrix_sde)                                  cell
%                                                               pm_pen(vector_benchmark_sd, matrix_sde)
%matrix_budget_data          data        matrix_budget          linear(matrix_budget)                              double
%matrix_budget_vars          vars        matrix_budget          linear(matrix_budget)                              cell
%vector_ubound_sd_data       data        vector_ubound_sd       MultiConstraint: <= vector_ubound_sd               double
%vector_benchmark_sd_data    data        vector_benchmark_sd    pm_pen(vector_benchmark_sd, matrix_sde)            double
%parameter_bound_data        data        parameter_bound        Constraint: = parameter_bound                      double
%parameter_bound_1_data      data        parameter_bound_1      Box: >= parameter_bound_1, <= parameter_bound_2    double
%parameter_bound_2_data      data        parameter_bound_2      Box: >= parameter_bound_1, <= parameter_bound_2    double
%
%Output variables:
%
%solution_str = string with solution of problem;
%outargstruc_arr = array of output PSG data structures;


function [solution_str,outargstruc_arr] = Optimization_subroutine(matrix_sde_data,matrix_sde_vars,matrix_budget_data,matrix_budget_vars,vector_ubound_sd_data,vector_benchmark_sd_data,parameter_bound_data,parameter_bound_1_data,parameter_bound_2_data)

%Pack data to PSG structure:
count = 0;
count = count+1;
iargstruc_arr(count) = matrix_pack('matrix_sde',matrix_sde_data,matrix_sde_vars,[],[]);
count = count+1;
iargstruc_arr(count) = matrix_pack('matrix_budget',matrix_budget_data,matrix_budget_vars,[],[]);
count = count+1;
iargstruc_arr(count) = vector_pack('vector_ubound_sd',vector_ubound_sd_data);
count = count+1;
iargstruc_arr(count) = vector_pack('vector_benchmark_sd',vector_benchmark_sd_data);
%Define problem statement:
problem_statement = sprintf('%s\n',...
'maximize',...
'  avg_g(matrix_sde)',...
'Constraint: = parameter_bound',...
'  linear(matrix_budget)',...
'MultiConstraint: <= vector_ubound_sd',...
'  pm_pen(vector_benchmark_sd, matrix_sde)',...
'Box: >= parameter_bound_1, <= parameter_bound_2',...
' ');
%Change parameters with their values in problem statement:
problem_statement = strrep(problem_statement,'parameter_bound_1',num2str(parameter_bound_1_data));
problem_statement = strrep(problem_statement,'parameter_bound_2',num2str(parameter_bound_2_data));
problem_statement = strrep(problem_statement,'parameter_bound',num2str(parameter_bound_data));

%Optimize problem using mpsg_solver function:
[solution_str, outargstruc_arr] = mpsg_solver(problem_statement, iargstruc_arr);
results = psg_convert_outargstruc(solution_str,outargstruc_arr);
outargstruc_arr = results.data;
solution_str = results.string;

%=======================================================================|
%American Optimal Decisions, Inc. Copyright                             |
%Copyright American Optimal Decisions, Inc. 2007-2016.                 |
%American Optimal Decisions (AOD) retains copyrights to this material.  |
%                                                                       |
%Permission to reproduce this document and to prepare derivative works  |
%from this document for internal use is granted, provided the copyright |
%and No Warranty  statements are included with all reproductions       |
%and derivative works.                                                  |
%                                                                       |
%For information regarding external or commercial use of copyrighted    |
%materials owned by AOD, contact AOD at support@aorda.com.              |
%=======================================================================|
 

